package DistLib;

/* data translated from C using perl script translate.pl */
/* script version 0.00                               */


import java.lang.*;
import java.lang.Math;
import java.lang.Double;

public class DistLib_h 
  { 
    /*
     *  DistLib : A C Library of Special Functions
     *  Copyright (C) 1998 R Core Team
     *
     *  This program is free software; you can redistribute it and/or modify
     *  it under the terms of the GNU General Public License as published by
     *  the Free Software Foundation; either version 2 of the License, or
     *  (at your option) any later version.
     *
     *  This program is distributed in the hope that it will be useful,
     *  but WITHOUT ANY WARRANTY; without even the implied warranty of
     *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     *  GNU General Public License for more details.
     *
     *  You should have received a copy of the GNU General Public License
     *  along with this program; if not, write to the Free Software
     *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
     *
    
     * DistLib.h  should contain ALL headers from R's C code in `src/nmath'
       ---------  such that ``the Math library'' can be used by simply
    
       ``#include "DistLib.h" ''
    
       and nothing else.
    */
    /*!* #ifndef MATHLIB_H /*4!*/
    /*!* #define MATHLIB_H *2!*/
    
    /*-- DistLib as part of R --  undefine this for standalone : */
    /*!* #define MATHLIB_IN_R *2!*/
    
    /*!* #include "Arith.h" /*4!*/
    /*!* #include "Random.h" /*4!*/
    
    /*!* #ifdef FORTRAN_H /*4!*/
    /*!* #error __MUST__include "DistLib.h"  _before_  "Fortran.h" /*4!*/
    /*!* #endif /*4!*/
    
    /*!* #include <errno.h> /*4!*/
    /*!* #include <limits.h> /*4!*/
    /*!* #include <float.h> /*4!*/
    /*!* #include <math.h> /*4!*/
    /*!* #include <stdlib.h> /*4!*/
    
    /* TRUE and FALSE conflict with the Mac --- Fortran.h still defines them... */
      //    public static final double  true = (1); 
      //    public static final double  false = (0); 
    
    /* 30 Decimal-place constants computed with bc -l (scale=32; proper round) */
    
    /*!* #ifndef M_SQRT_2 /*4!*/
    public static final double  M_SQRT_2 = 1.4142135623730950488016887242097; 
    public static final double  M_1_SQRT_2 = 0.707106781186547524400844362105; 
/* 1/sqrt(2) */
    public static final double  M_SQRT_32 = 5.656854249492380195206754896838; 
/* sqrt(32) */
    /*!* #endif /*4!*/
    
    /*!* #ifndef M_LN_2 /*4!*/
    public static final double  M_LN_2 = 0.693147180559945309417232121458176568; 
    public static final double  M_LOG10_2 = 0.301029995663981195213738894724493027; 
    /*!* #endif /*4!*/
    
    /*!* #ifndef M_PI /*4!*/
    public static final double  M_PI   = 3.141592653589793238462643383279502884197169399375; 
    /*!* #endif /*4!*/
    /*!* #ifndef M_PI_half /*4!*/
    public static final double  M_PI_half = 1.570796326794896619231321691640; 
    /*!* #endif /*4!*/

    /* 1/pi */
    public static final double  M_1_PI =  0.31830988618379067153776752674502872406891929148;

   /* pi/2 */
    public static final double  M_PI_2 =  1.57079632679489661923132169163975144209858469969;

    
    /*!* #ifndef M_SQRT_PI /*4!*/
    /* sqrt(pi),  1/sqrt(2pi),  sqrt(2/pi) : */
    public static final double  M_SQRT_PI = 1.772453850905516027298167483341; 
    public static final double  M_1_SQRT_2PI = 0.398942280401432677939946059934; 
    public static final double  M_SQRT_2dPI = 0.79788456080286535587989211986876; 
    /*!* #endif /*4!*/
    
    
    /*!* #ifndef M_LN_SQRT_PI /*4!*/
    /* log(sqrt(pi)) = log(pi)/2 : */
    public static final double  M_LN_SQRT_PI = 0.5723649429247000870717136756765293558; 
    /* log(sqrt(2*pi)) = log(2*pi)/2 : */
    public static final double  M_LN_SQRT_2PI = 0.91893853320467274178032973640562; 
    /* log(sqrt(pi/2)) = log(pi/2)/2 : */
    public static final double  M_LN_SQRT_PId2 = 0.225791352644727432363097614947441; 
    /*!* #endif /*4!*/
    
    
    /*!* #ifdef MATHLIB_IN_R/* DistLib in R */ /*4!*/
    
    /*!* #include "Error.h" /*4!*/
    /*!* # define MATHLIB_ERROR(fmt,x)		error(fmt,x); *2!*/
    /*!* # define System.out.println(fmt+x)		warning(fmt+x) *2!*/
    /*!* # define System.out.println(fmt+x+x2)	warning(fmt+x+x2) *2!*/
    /*!* # define System.out.println(fmt+x+x2+x3)	warning(fmt+x+x2+x3) *2!*/
    /*!* # define System.out.println(fmt+x+x2+x3+x4) warning(fmt+x+x2+x3+x4) *2!*/
    
    /*!* #else/* DistLib standalone */ /*4!*/
    
    /*!* #include <stdio.h> /*4!*/
    /*!* # define MATHLIB_ERROR(fmt,x)   { printf(fmt,x); exit(1) } *2!*/
    /*!* # define System.out.println(fmt+x)		printf(fmt+x) *2!*/
    /*!* # define System.out.println(fmt+x+x2)	printf(fmt+x+x2) *2!*/
    /*!* # define System.out.println(fmt+x+x2+x3)	printf(fmt+x+x2+x3) *2!*/
    /*!* # define System.out.println(fmt+x+x2+x3+x4) printf(fmt+x+x2+x3+x4) *2!*/
    /*!* #endif /*4!*/
    
    public static final double  ME_NONE = 0; 
    public static final double  ME_DOMAIN = 1; 
    public static final double  ME_RANGE = 2; 
    public static final double  ME_NOCONV = 3; 
    public static final double  ME_PRECISION = 4; 
    public static final double  ME_UNDERFLOW = 5; 

    /* constants taken from float.h for gcc 2.90.29 for Linux 2.0 i386  */
    /* -- should match Java since both are supposed to be IEEE 754 compliant */

    /* Radix of exponent representation */
    public static final int    FLT_RADIX   = 2;

    /* Difference between 1.0 and the minimum float/double greater than 1.0 */
    public static final double FLT_EPSILON = 1.19209290e-07F;
    public static final double DBL_EPSILON = 2.2204460492503131e-16; 
    
    /* Number of decimal digits of precision in a float/double */
    public static final int FLT_DIG = 6;
    public static final int DBL_DIG = 15;          

    /* Number of base-FLT_RADIX digits in the significand of a double */
    public static final int FLT_MANT_DIG = 24;
    public static final int DBL_MANT_DIG = 53;

    /* Minimum int x such that FLT_RADIX**(x-1) is a normalised double */
    public static final int FLT_MIN_EXP = -125;
    public static final int DBL_MIN_EXP = -1021;

    /* Maximum int x such that FLT_RADIX**(x-1) is a representable double */
    public static final int FLT_MAX_EXP = 128;
    public static final int DBL_MAX_EXP = 1024;

    /*!* #undef ML_PRECISION_WARNINGS /*4!*/
    
    /*!* #ifdef IEEE_754 /*4!*/
    /*!* #ifdef HAVE_IEEE754_H /*4!*/
    /*!* #include <ieee754.h> /* newer Linuxen */ /*4!*/
    /*!* #else /*4!*/
    /*!* #ifdef HAVE_IEEEFP_H /*4!*/
    /*!* #include <ieeefp.h> /* others [Solaris 2.5.x], .. */ /*4!*/
    /*!* #endif /*4!*/
    /*!* #endif /*4!*/
    
    /*!* extern double m_zero; /*!*/
    /*!* extern double m_one; /*!*/
    /*!* extern double m_tiny; /*!*/
    /*!* #define throw new java.lang.ArithmeticException(x)	/* nothing */ /*1!*/
    /*!* #define Double.POSITIVE_INFINITY	(m_one / m_zero) /*1!*/
    /*!* #define Double.NEGATIVE_INFINITY	((-m_one) / m_zero) /*1!*/
    /*!* #define Double.NaN		(m_zero / m_zero) /*1!*/
    /*!* #define (Double.MIN_VALUE * Double.MIN_VALUE)	(m_tiny * m_tiny) /*1!*/
    /*!* #define !Double.isNaN(x)	(!isnan(x)) /*1!*/
    /*!* #else /*4!*/
    /*!* #define throw new java.lang.ArithmeticException(x)	ml_error(x) /*1!*/
    /*!* #define Double.POSITIVE_INFINITY	Double.MAX_VALUE /*1!*/
    /*!* #define Double.NEGATIVE_INFINITY	(-Double.MAX_VALUE) /*1!*/
    /*!* #define Double.NaN		(-Double.MAX_VALUE) /*1!*/
    /*!* #define (Double.MIN_VALUE * Double.MIN_VALUE)	0 /*1!*/
    /*!* #define !Double.isNaN(x)	(errno == 0) /*1!*/
    /*!* #endif /*4!*/
    
    	/* Splus Compatibility */
      /*
	public static final double  snorm = norm_rand; 
	public static final double  sunif = unif_rand; 
	public static final double  sexp = exp_rand; 
      */
    	/* Undo SGI Madness */
    
    /*!* #ifdef ftrunc /*4!*/
    /*!* #undef ftrunc /*4!*/
    /*!* #endif /*4!*/
    /*!* #ifdef qexp /*4!*/
    /*!* #undef qexp /*4!*/
    /*!* #endif /*4!*/
    
    	/* Name Hiding to Avoid Clashes with Fortran */
    
    /*!* #ifdef HIDE_NAMES /*4!*/
      /*
	public static final double  d1mach = c_d1mach; 
	public static final double  i1mach = c_i1mach; 
      */
    /*!* #endif /*4!*/
      /*
	public static final double  rround = fround; 
	public static final double  prec = fprec; 
	public static final double  trunc = ftrunc; 
      */
    	/* Machine Characteristics */
    
    /*!* double	d1mach(int) /*4!*/
    /*!* double	d1mach_(int*) /*4!*/
    /*!* int	i1mach(int) /*4!*/
    /*!* int	i1mach_(int*) /*4!*/
    
    	/* General Support Functions */
    
    /*!* int	imax2(int, int) /*4!*/
    /*!* int	Math.min(int, int) /*4!*/
    /*!* double	fmax2(double, double) /*4!*/
    /*!* double	fmin2(double, double) /*4!*/
    /*!* double	fmod(double, double) /*4!*/
    /*!* double	fprec(double, double) /*4!*/
    /*!* double	fround(double, double) /*4!*/
    /*!* double	ftrunc(double) /*4!*/
    /*!* double	sign(double) /*4!*/
    /*!* double	fsign(double, double) /*4!*/
    /*!* double	fsquare(double) /*4!*/
    /*!* double	fcube(double) /*4!*/
    
    	/* Random Number Generators */
    
    /*!* double	snorm(void) /*4!*/
    /*!* double	sunif(void) /*4!*/
    /*!* double	sexp(void) /*4!*/
    
    	/* Chebyshev Series */
    
    /*!* int	chebyshev_init(double*, int, double) /*4!*/
    /*!* double	chebyshev_eval(double, double *, int) /*4!*/
    
    	/* Gamma and Related Functions */
    
    /*!* double	logrelerr(double) /*4!*/
    /*!* void	gammalims(double*, double*) /*4!*/
    /*!* double	lgammacor(double) /*4!*/
    /*!* double	gammafn(double) /*4!*/
    /*!* double	gamma_cody(double) /*4!*/
    /*!* double	lgammafn(double) /*4!*/
    /*!* void	dpsifn(double, int, int, int, double*, int*, int*) /*4!*/
    /*!* double	digamma(double) /*4!*/
    /*!* double	trigamma(double) /*4!*/
    /*!* double	tetragamma(double) /*4!*/
    /*!* double	pentagamma(double) /*4!*/
    
    /*!* double	choose(double, double) /*4!*/
    /*!* double	lchoose(double, double) /*4!*/
    /*!* double	fastchoose(double, double) /*4!*/
    /*!* double	lfastchoose(double, double) /*4!*/
    
    	/* Bessel Functions of All Kinds */
    
    /*!* double  bessel_i(double, double, double) /*4!*/
    /*!* double  bessel_j(double, double) /*4!*/
    /*!* double  bessel_k(double, double, double) /*4!*/
    /*!* double  bessel_y(double, double) /*4!*/
    /*!* void    I_bessel(double*, double*, long*, long*, double*, long*) /*4!*/
    /*!* void    J_bessel(double*, double*, long*,        double*, long*) /*4!*/
    /*!* void 	K_bessel(double*, double*, long*, long*, double*, long*) /*4!*/
    /*!* void	Y_bessel(double*, double*, long*,        double*, long*) /*4!*/
    
    	/* Beta and Related Functions */
    
    /*!* double	beta(double, double) /*4!*/
    /*!* double	lbeta(double, double) /*4!*/
    
    	/* Normal Distribution */
    
    /*!* double	dnorm(double, double, double) /*4!*/
    /*!* double	pnorm(double, double, double) /*4!*/
    /*!* double	qnorm(double, double, double) /*4!*/
    /*!* double	rnorm(double, double) /*4!*/
    
    	/* Uniform Distribution */
    
    /*!* double	dunif(double, double, double) /*4!*/
    /*!* double	punif(double, double, double) /*4!*/
    /*!* double	qunif(double, double, double) /*4!*/
    /*!* double	runif(double, double) /*4!*/
    
    	/* Gamma Distribution */
    
    /*!* double	dgamma(double, double, double) /*4!*/
    /*!* double	pgamma(double, double, double) /*4!*/
    /*!* double	qgamma(double, double, double) /*4!*/
    /*!* double	rgamma(double, double) /*4!*/
    
    	/* Beta Distribution */
    
    /*!* double	dbeta(double, double, double) /*4!*/
    /*!* double	pbeta(double, double, double) /*4!*/
    /*!* double	pbeta_raw(double, double, double) /*4!*/
    /*!* double	qbeta(double, double, double) /*4!*/
    /*!* double	rbeta(double, double) /*4!*/
    
    	/* Lognormal Distribution */
    
    /*!* double	dlnorm(double, double, double) /*4!*/
    /*!* double	plnorm(double, double, double) /*4!*/
    /*!* double	qlnorm(double, double, double) /*4!*/
    /*!* double	rlnorm(double, double) /*4!*/
    
    	/* Chi-squared Distribution */
    
    /*!* double	dchisq(double, double) /*4!*/
    /*!* double	pchisq(double, double) /*4!*/
    /*!* double	qchisq(double, double) /*4!*/
    /*!* double	rchisq(double) /*4!*/
    
    	/* Non-central Chi-squared Distribution */
    
    /*!* double	dnchisq(double, double, double) /*4!*/
    /*!* double	pnchisq(double, double, double) /*4!*/
    /*!* double	qnchisq(double, double, double) /*4!*/
    /*!* double	rnchisq(double, double) /*4!*/
    
    	/* F Distibution */
    
    /*!* double	df(double, double, double) /*4!*/
    /*!* double	pf(double, double, double) /*4!*/
    /*!* double	qf(double, double, double) /*4!*/
    /*!* double	rf(double, double) /*4!*/
    
    	/* Student t Distibution */
    
    /*!* double	dt(double, double) /*4!*/
    /*!* double	pt(double, double) /*4!*/
    /*!* double	qt(double, double) /*4!*/
    /*!* double	rt(double) /*4!*/
    
    	/* Binomial Distribution */
    
    /*!* double	dbinom(double, double, double) /*4!*/
    /*!* double	pbinom(double, double, double) /*4!*/
    /*!* double	qbinom(double, double, double) /*4!*/
    /*!* double	rbinom(double, double) /*4!*/
    
    	/* Cauchy Distribution */
    
    /*!* double	dcauchy(double, double, double) /*4!*/
    /*!* double	pcauchy(double, double, double) /*4!*/
    /*!* double	qcauchy(double, double, double) /*4!*/
    /*!* double	rcauchy(double, double) /*4!*/
    
    	/* Exponential Distribution */
    
    /*!* double	dexp(double, double) /*4!*/
    /*!* double	pexp(double, double) /*4!*/
    /*!* double	qexp(double, double) /*4!*/
    /*!* double	rexp(double) /*4!*/
    
    	/* Geometric Distribution */
    
    /*!* double	dgeom(double, double) /*4!*/
    /*!* double	pgeom(double, double) /*4!*/
    /*!* double	qgeom(double, double) /*4!*/
    /*!* double	rgeom(double) /*4!*/
    
    	/* Hypergeometric Distibution */
    
    /*!* double	dhyper(double, double, double, double) /*4!*/
    /*!* double	phyper(double, double, double, double) /*4!*/
    /*!* double	qhyper(double, double, double, double) /*4!*/
    /*!* double	rhyper(double, double, double) /*4!*/
    
    	/* Negative Binomial Distribution */
    
    /*!* double	dnbinom(double, double, double) /*4!*/
    /*!* double	pnbinom(double, double, double) /*4!*/
    /*!* double	qnbinom(double, double, double) /*4!*/
    /*!* double	rnbinom(double, double) /*4!*/
    
    	/* Poisson Distribution */
    
    /*!* double	dpois(double, double) /*4!*/
    /*!* double	ppois(double, double) /*4!*/
    /*!* double	qpois(double, double) /*4!*/
    /*!* double	rpois(double) /*4!*/
    
    	/* Weibull Distribution */
    
    /*!* double	dweibull(double, double, double) /*4!*/
    /*!* double	pweibull(double, double, double) /*4!*/
    /*!* double	qweibull(double, double, double) /*4!*/
    /*!* double	rweibull(double, double) /*4!*/
    
    	/* Logistic Distribution */
    
    /*!* double	dlogis(double, double, double) /*4!*/
    /*!* double	plogis(double, double, double) /*4!*/
    /*!* double	qlogis(double, double, double) /*4!*/
    /*!* double	rlogis(double, double) /*4!*/
    
    	/* Non-central Beta Distribution */
    
    /*!* double	dnbeta(double, double, double, double) /*4!*/
    /*!* double	pnbeta(double, double, double, double) /*4!*/
    /*!* double	qnbeta(double, double, double, double) /*4!*/
    /*!* double	rnbeta(double, double, double) /*4!*/
    
    	/* Non-central F Distribution */
    
    /*!* double	dnf(double, double, double, double) /*4!*/
    /*!* double	pnf(double, double, double, double) /*4!*/
    /*!* double	qnf(double, double, double, double) /*4!*/
    /*!* double	rnf(double, double, double) /*4!*/
    
    	/* Non-central Student t Distribution */
    
    /*!* double	dnt(double, double, double) /*4!*/
    /*!* double	pnt(double, double, double) /*4!*/
    /*!* double	qnt(double, double, double) /*4!*/
    /*!* double	rnt(double, double) /*4!*/
    
    	/* Studentized Range Distribution */
    
    /*!* double	dtukey(double, double, double, double) /*4!*/
    /*!* double	ptukey(double, double, double, double) /*4!*/
    /*!* double	qtukey(double, double, double, double) /*4!*/
    /*!* double	rtukey(double, double, double) /*4!*/
    
    /*!* double dwilcox(double, double, double) /*4!*/
    /*!* double pwilcox(double, double, double) /*4!*/
    /*!* double qwilcox(double, double, double) /*4!*/
    /*!* double rwilcox(double, double) /*4!*/
    
    /* Wilcoxon Signed Rank Distribution */
      /*
	public static final double  SIGNRANK_NMAX = 50; 
      */
    /*!* double dsignrank(double, double) /*4!*/
    /*!* double psignrank(double, double) /*4!*/
    /*!* double qsignrank(double, double) /*4!*/
    /*!* double rsignrank(double) /*4!*/
    
    /*!* #endif /*4!*/
  }
